HDU 2955 Robberies(DP)

题目网址:http://acm.hdu.edu.cn/showproblem.php?pid=2955

题目:

Problem Description

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.


For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

Input

The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj . 
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

Output

For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

Sample Input

3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

Sample Output

2
4
6

题意:

给定一个概率,被抓的概率要小于它。然后给出若干个银行的金额和抢劫被抓的概率。求在满足被抓概率小于所给概率的情况下,能获得的最大金额数。

思路:

概率dp题。被抓的情况有很多种,不好一个个去算,所以我们换个角度来计算,即P(被抓)=1-P(逃脱),最后用1-P(逃脱)< P(给定的)来判定。这道题显然是将金额当做背包容量,求得在获得金额相同时,逃脱的概率最大。

状态转移:dp[j]=max(dp[j], dp[j-bank[i].m]*(1-bank[i].p));我们让dp[0]=1,则第一次抢劫一个银行时,则逃脱的概率就等于1-P(被抓)。

代码:

 1 #include <cstdio>
 2 #include <cstring>
 3 #include <algorithm>
 4 using namespace std;
 5 int n;
 6 double dp[10005];
 7 double p;
 8 struct node{
 9     int m;
10     double p;
11 }bank[105];
12 int main(){
13     int t;
14     scanf("%d",&t);
15     while (t--) {
16         int total=0;
17         memset(dp, 0, sizeof(dp));
18         scanf("%lf%d",&p,&n);
19         for (int i=0; i<n; i++){
20             scanf("%d%lf",&bank[i].m,&bank[i].p);
21             total+=bank[i].m;//算出不计概率的情况下,金额总数
22         }
23         dp[0]=1;
24         for (int i=0; i<n; i++) {
25             for (int j=total; j>=bank[i].m; j--) {
26                 dp[j]=max(dp[j], dp[j-bank[i].m]*(1-bank[i].p));
27             }
28         }
29         for (int i=total; i>=0; i--) {
30             if(1-dp[i]<p){//dp[i]是逃脱的概率,1-dp[i]是被抓的概率
31                 printf("%d\n",i);
32                 break;
33             }
34         }
35     }
36     return 0;
37 }
时间: 2024-10-07 06:30:18

HDU 2955 Robberies(DP)的相关文章

HDU 2955 Robberies dp +背包

题目链接~~http://acm.hdu.edu.cn/showproblem.php?pid=2955 题意 : 在不被抓住的情况下,偷的钱最多, 然后题目给的是被抓住的概率~ 就可以考虑在不被抓住的情况下,拿的最多的钱.. 还RT了一回    %>_<% 状态方程: dp[j]=max(dp[j],dp[j-a[i]]*p1[i]); 代码:: 1 #include <iostream> 2 #include <cstdio> 3 #include <cmat

HDU 2955 Robberies --01背包变形

这题有些巧妙,看了别人的题解才知道做的. 因为按常规思路的话,背包容量为浮点数,,不好存储,且不能直接相加,所以换一种思路,将背包容量与价值互换,即令各银行总值为背包容量,逃跑概率(1-P)为价值,即转化为01背包问题. 此时dp[v]表示抢劫到v块钱成功逃跑的概率,概率相乘. 最后从大到小枚举v,找出概率大于逃跑概率的最大v值,即为最大抢劫的金额. 代码: #include <iostream> #include <cstdio> #include <cstring>

HDU 2955 Robberies (01背包)

Robberies Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 11297    Accepted Submission(s): 4190 Problem Description The aspiring Roy the Robber has seen a lot of American movies, and knows that

HDU 2955 Robberies 背包概率DP

A - Robberies Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 2955 Appoint description: Description The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usu

(背包dp)HDU - 2955 Robberies

原题链接:http://acm.split.hdu.edu.cn/showproblem.php?pid=2955 (可能失效) 题意:小偷抢劫n个银行,每个银行有两个属性,m为拥有的库存金额,p为小偷偷这个银行被抓的概率.小偷抢银行的总被抓概率不能超过V.求最多抢到的金额. 分析:这题拿到手很容易想到把概率*100,以总概率V为背包容积,以抢到的金额为价值跑01背包. 但是确实本题坑之所在.WA了好多发. 看了大神博客才明白,这里需要一个转化,直接跑以总金额sum为容积,不被抓的概率为价值的背

hdu 2955 Robberies(背包DP)

题意: 小偷去抢银行,他母亲很担心. 他母亲希望他被抓的概率真不超过P.小偷打算去抢N个银行,每个银行有两个值Mi.Pi,Mi:抢第i个银行所获得的财产 Pi:抢第i个银行被抓的概率 求最多能抢得多少财产. 思路: 由于概率不是整数,所以不能将其作为背包容量.继续观察,发现Mi是整数,调整思路可发现,可以将财产作为背包容量,求一定财产内的被抓的最小概率.这样只需要判断这个概率是否小于等于P即可. 代码: double P; int N; int m[105]; double p[105]; do

HDU 2955 Robberies(0-1背包)

http://acm.hdu.edu.cn/showproblem.php?pid=2955 题意:一个抢劫犯要去抢劫银行,给出了几家银行的资金和被抓概率,要求在被抓概率不大于给出的被抓概率的情况下,计算出所能抢劫得到的最多资金. 思路:一开始把被抓概率当做背包容量来做,结果错了,很重要的一点就是逃脱概率的计算,不是简单的相加相减,而是在上一家银行抢劫时的逃脱概率再乘以这一次的逃脱概率. 举个例子: 三家银行的被抓概率为P1,P2,P3.那么去抢劫这三家银行的逃脱概率为(1-P1)*(1-P2)

[HDU 2955]Robberies (动态规划)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2955 题意是给你一个概率P,和N个银行 现在要去偷钱,在每个银行可以偷到m块钱,但是有p的概率被抓 问你被抓的概率在P以下,最多能偷多少钱. 刚开始我还在想,A银行被抓的概率是a,B银行被抓的概率是b,那么偷A和B被抓的概率是a*b.. 傻逼了- -..a*b是既被A银行抓又被B银行抓.. 所以用逃跑的概率计算 dp[i][j]代表从前i个银行里偷了j元逃跑的最大概率 代码: 1 #include

hdu 2955 Robberies(01背包)

Robberies Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 17723    Accepted Submission(s): 6544 Problem Description The aspiring Roy the Robber has seen a lot of American movies, and knows that